// Override resources directories with our add-on ones.
function addResourceAlias() {
  let environment = Components.classes["@mozilla.org/process/environment;1"]
                      .getService(Components.interfaces.nsIEnvironment);
  let topsrcdir = Components.classes["@mozilla.org/file/local;1"]
                    .createInstance(Components.interfaces.nsILocalFile);
  topsrcdir.initWithPath(environment.get("TOPSRCDIR"));
  topsrcdir.append("dist");
  topsrcdir.append("stage");

  let services_sync = topsrcdir.clone();
  services_sync.append("modules");

  let services_crypto = topsrcdir.clone();
  services_crypto.append("crypto-modules");

  let ioService = Components.classes["@mozilla.org/network/io-service;1"]
                    .getService(Components.interfaces.nsIIOService);
  let resProt = ioService.getProtocolHandler("resource")
                  .QueryInterface(Components.interfaces.nsIResProtocolHandler);

  resProt.setSubstitution("services-sync", ioService.newFileURI(services_sync));
  resProt.setSubstitution("services-crypto", ioService.newFileURI(services_crypto));
}
addResourceAlias();
